var express = require('express')
var webpack = require('webpack')
var config = require('./webpack.dev.conf')
var proxyMiddleware = require('http-proxy-middleware')
// var httpProxy = require('http-proxy')

var app = express()
var compiler = webpack(config)
// var proxy = httpProxy.createProxyServer()

// Define HTTP proxies to your custom API backend
// https://github.com/chimurai/http-proxy-middleware
/* var str = 'http://192.168.50.220:8300', str2 = 'http://192.168.50.220:7000/ldap'*/
var proxyTable = {
  /* 'images': {
    target: 'http://127.0.0.1:8016/system'
  },
  '/rs/search': {
    // target: 'http://127.0.0.1:8080'
    target: 'http://127.0.0.1:32145/ldap'
  },
  // 用户登录服务地址
  '/rs/user': {
    target: 'http://127.0.0.1:32145/ldap'
  },
  '/rs/path/getParams': {
    target: 'http://127.0.0.1:8016/system'
    //target: 'http://192.168.50.220:8300/system'
  },
  '/rs/logic/getInitData': {
    target: 'http://127.0.0.1:8016/system'
    //target: 'http://192.168.50.220:8300/system'
  },
  '/rs/logic/getLogin': {
    target: 'http://127.0.0.1:8016/system'
    //target: 'http://192.168.50.220:8300/system'
  },*/
  '/rs': {
    // target: 'http://192.168.50.222:8300'
    // target: 'http://127.0.0.1:32145/ldap'
    // target: 'http://127.0.0.1:32145/ldap'
    target: 'http://111.19.162.41:8301/'
  }

/*  '/file': {
    // target: 'http://localhost:8086'
    target: str
  },
  // 查找资源服务数据
  '/rs/search': {
    // target: 'http://192.168.50.202:8099'
    // target: 'http://192.168.20.2:8081'
    target: str2
    // target: 'http://192.168.20.191:8011'
  },
  // 用户登录服务地址
  '/rs/user': {
    // target: 'http://192.168.50.202:8099'
    // target: 'http://192.168.2.77:8081'
    target: str2
    // target: 'http://192.168.20.191:8011'
  },
  '/rs/path/getParams': {
    // target: 'http://192.168.50.202:8099'
    // target: 'http://127.0.0.1:8888/product'
    target: str
    // target: 'http://192.168.20.191:8011'
  },
  '/rs/logic/getInitData': {
    target: str
  },
  '/rs/db': {
    target: str2
  },
  '/excel': {
    target: 'http://192.168.50.220:8300'
  },
  '/rs/logic/getLogin': {
    target: str
  },
  '/rs/config': {
    target: str
  },
  '/rs/Invoice': {
    target: 'http://127.0.0.1:8090/Invoice/rs/aisino/invoice'
  },
  '/rs': {
    // target: 'http://localhost:8080'
    target: str
    // target: 'http://127.0.0.1:8082/revenue'
  }*/
}

var devMiddleware = require('webpack-dev-middleware')(compiler, {
  publicPath: config.output.publicPath,
  stats: {
    colors: true,
    chunks: false
  }
})

var hotMiddleware = require('webpack-hot-middleware')(compiler)
// force page reload when html-webpack-plugin template changes
compiler.plugin('compilation', function (compilation) {
  compilation.plugin('html-webpack-plugin-after-emit', function (data, cb) {
    hotMiddleware.publish({action: 'reload'})
    cb()
  })
})

// proxy api requests
Object.keys(proxyTable).forEach(function (context) {
  var options = proxyTable[context]
  if (typeof options === 'string') {
    options = {target: options}
  }
  app.use(proxyMiddleware(context, options))
})

// handle fallback for HTML5 history API
app.use(require('connect-history-api-fallback')())
// app.use(function (req, res, next) {
//   res.header('Access-Control-Allow-Origin', '*')
//   res.header('Access-Control-Allow-Headers', 'X-Requested-With')
//   res.header('Access-Control-Allow-Methods', 'PUT, POST, GET,DELETE, OPTIONS')
//   res.header('X-Powered-By', '3,2,1')
//   res.header('Access-Control-Allow-Credentials', 'true')
//   res.header('Content-Type', 'application/json;charset=utf-8')
//   next()
// })

// serve webpack bundle output
app.use(devMiddleware)

// enable hot-reload and state-preserving
// compilation error display
app.use(hotMiddleware)

// serve pure static assets
app.use('/static', express.static('./static'))

module.exports = app.listen(8084, function (err) {
  if (err) {
    console.log(err)
    return
  }
  console.log('Listening at http://localhost:8083')
})
