var webpack = require('webpack')
var merge = require('webpack-merge')
var baseConfig = require('./webpack.base.conf')
var HtmlWebpackPlugin = require('html-webpack-plugin')
const ExtractTextPlugin = require('extract-text-webpack-plugin')
module.exports = merge(baseConfig, {
  devtool: 'eval-cheap-module-source-map',
  output: {
    publicPath: '/'
  },
  stats: {
    all: false, // 关闭全部日志
    colors: true, // 配置控制台输出彩色日志
    errors: true, // 输出构建错误日志
    warnings: true, // 输出构建警告日志
    moduleTrace: true, // 显示 module 路径信息
    errorDetails: true, // 显示构建错误的详细信息
    chunks: false, // 不输出构建 chunk 信息
    entrypoints: false, // 不输出入口文件信息
    children: false, // 不输出子模块构建信息
    performance: true // 输出性能提示
  },
  plugins: [
    new webpack.HotModuleReplacementPlugin(),
    new webpack.NoEmitOnErrorsPlugin(),
    new ExtractTextPlugin('[name].css'),
    // https://github.com/ampedandwired/html-webpack-plugin
    new HtmlWebpackPlugin({
      filename: 'index.html',
      template: 'index.html',
      inject: true,
      date: new Date().getTime()
    })
  ]
})
